config/routes.rb
QuestionBank::Application.routes.draw do
  resources :user_groups

  resources :question_groups

  resources :tags

  resources :attempts

  resources :questions

  get '/questions/quiz/new' => 'questions#prepare_quiz', :as => 'prepare_quiz'
  post '/questions/quiz/new'=> 'questions#generate_quiz', :as => 'generate_quiz'
  match '/questions/quiz/tag/:tag/num/:number_of_questions/show' => 'questions#show_quiz', :as => 'show_quiz'

  get '/downloads/new' => 'downloads#new', :as => 'new_download'
  post '/downloads' => 'downloads#create', :as => 'create_download'

  get '/uploads/new' => 'uploads#new', :as => 'new_upload'
  post '/uploads' => 'uploads#create', :as => 'create_upload'
  get '/uploads/attribute/new' => 'uploads#new_attribute', :as => 'new_attribute'
  post '/uploads/attribute/new' => 'uploads#create_attribute', :as => 'create_attribute'

  post '/api/event/new' => 'api#new_event'
  
  root :to => "home#index"
  resources :users, :only => [:index, :show, :edit, :update ]
  match '/auth/:provider/callback' => 'sessions#create'
  match '/signin' => 'sessions#new', :as => :signin
  match '/signout' => 'sessions#destroy', :as => :signout
  match '/auth/failure' => 'sessions#failure'
end

app/models/question_group.rb
class QuestionGroup < ActiveRecord::Base
	has_and_belongs_to_many :questions
	belongs_to :user

	resourcify
end

app/controllers/question_groups_controller.rb
class QuestionGroupsController < ApplicationController
  load_and_authorize_resource
  # GET /question_groups
  # GET /question_groups.json
  def index
    @question_groups = QuestionGroup.accessible_by(current_ability)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @question_groups }
    end
  end

  # GET /question_groups/1
  # GET /question_groups/1.json
  def show
    @question_group = QuestionGroup.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @question_group }
    end
  end

  # GET /question_groups/new
  # GET /question_groups/new.json
  def new
    @question_group = QuestionGroup.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @question_group }
    end
  end

  # GET /question_groups/1/edit
  def edit
    @question_group = QuestionGroup.find(params[:id])
  end

  # POST /question_groups
  # POST /question_groups.json
  def create
    @question_group = QuestionGroup.new(params[:question_group])

    respond_to do |format|
      if @question_group.save
        format.html { redirect_to @question_group, notice: 'Question group was successfully created.' }
        format.json { render json: @question_group, status: :created, location: @question_group }
      else
        format.html { render action: "new" }
        format.json { render json: @question_group.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /question_groups/1
  # PUT /question_groups/1.json
  def update
    @question_group = QuestionGroup.find(params[:id])

    respond_to do |format|
      if @question_group.update_attributes(params[:question_group])
        format.html { redirect_to @question_group, notice: 'Question group was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @question_group.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /question_groups/1
  # DELETE /question_groups/1.json
  def destroy
    @question_group = QuestionGroup.find(params[:id])
    @question_group.destroy

    respond_to do |format|
      format.html { redirect_to question_groups_url }
      format.json { head :no_content }
    end
  end
end

app/helpers/question_groups_helper.rb
module QuestionGroupsHelper
end

app/views/question_groups/_form.html.haml
= simple_form_for(@question_group) do |f|
  = f.error_notification

  .form-inputs

  .form-actions
    = f.button :submit

app/views/question_groups/edit.html.haml
%h1 Editing question_group

= render 'form'

= link_to 'Show', @question_group
\|
= link_to 'Back', question_groups_path

app/views/question_groups/index.html.haml
%h1 Listing question_groups

%table
  %tr
    %th Group name
    %th
    %th
    %th

  - @question_groups.each do |question_group|
    %tr
      %td= question_group.name
      %td= link_to 'Show', question_group
      %td= link_to 'Edit', edit_question_group_path(question_group)
      %td= link_to 'Destroy', question_group, method: :delete, data: { confirm: 'Are you sure?' }

%br

= link_to 'New Question group', new_question_group_path

app/views/question_groups/new.html.haml
%h1 New question_group

= render 'form'

= link_to 'Back', question_groups_path

app/views/question_groups/show.html.haml
%p#notice= notice


= link_to 'Edit', edit_question_group_path(@question_group)
\|
= link_to 'Back', question_groups_path